#include "ASantaxique.h"
#include "ALexical.h"
#include"Production.h"
#include<stack>
#include "Terminal.h"
#include "ASemantique.h"
#include<iomanip>
#include "Item.h"
#include "NonTerminal.h"
#include<sstream>
#include<fstream> 
#include<iostream>
using namespace std;

void ASantaxique::activerGenerationCode(bool f){
generation = f;

}
void ASantaxique::activerAffichageAnalyse(bool actif){
affichage = actif;

}
ASantaxique::ASantaxique(char* fichier_grammaire,char* lexical,int nb_terminal,int nb_nterminal,int nb_prod)
:analyseurlexical(lexical)
{
	affichage = false;
	generation = false;
	terminaux.reserve(nb_terminal);
	sterminaux.reserve(nb_terminal);
	nterminaux.reserve(nb_nterminal);
	snterminaux.reserve(nb_nterminal);
	successeur.reserve(200);
	action.reserve(200);
	grammaire.reserve(nb_prod);
	chargerGrammaire(fichier_grammaire);

	calculerPremier();
	calculerSuivant();

	creerCollectionItem();
	//afficherCollectionItem();
	construireTableAnalyse();
	//afficherTableAnalyse();


	


}

void ASantaxique::chargerGrammaire(char* fichier_grammaire)
{
	int index=0;
	terminaux.push_back("epsilon");
	sterminaux.push_back(new Terminal(0));
	terminaux.push_back(MARQUEUR_FIN);
	sterminaux.push_back(new Terminal(1));

	ifstream ifs(fichier_grammaire);

	if(ifs.bad()){
		cout << "Erreu lors de l'ouverture du fichier du grammaire" << endl;
		exit(1);
	}
	string temp;
	ifs >> temp;
	if(temp!="terminal"){
		cout<< "Erreur dans la grammaire, elle doit commencer par 'terminal'"<<endl;
		exit(2);
	}
	ifs >> temp;
	while(!ifs.eof()){
		while(temp != "nonterminal" && !ifs.eof()){

			terminaux.push_back(temp); 

			Terminal* t =  new Terminal(sterminaux.size());
			sterminaux.push_back(t);
			ifs >> temp;
		}
		if(ifs.eof()){
			cout<< "Erreur dans la grammaire, elle doit contenir 'nonterminal' apres la section terminal"<<endl;
			exit(2);
		}
		ifs >> temp;
		while(temp != "indication" && !ifs.eof()){
			snterminaux.push_back(new NonTerminal(snterminaux.size()));
			nterminaux.push_back(temp);
			ifs >> temp;
		}

		if(ifs.eof()){
			cout<< "Erreur dans la grammaire, elle doit contenir le champ 'indication'"<<endl;
			exit(3);
		}
		ifs >> temp;
		while(temp!="grammaire" && !ifs.eof()){
			ifs >> temp;
			//travaille pour indication
		}
		if(ifs.eof()){
			cout<< "Erreur dans la grammaire, elle doit contenir le champ 'grammaire'"<<endl;
			exit(4);
		}

		while(!ifs.eof()){

			ifs >> temp; 
			if((index=indexDuNonTerminal(temp))==-1 ){
				cout<< "Erreur dans la grammaire: symbole '" << temp << "' non declar"<<endl;
				exit(4);

			}
			//NonTerminal* ntermianltemp = new NonTerminal(index);
			Production* prod = new Production(snterminaux[index]);
			ifs >> temp;
			if(temp!="="){
				cout<< "Erreur dans la grammaire: partie gauche du production doit etre suivie par partie droite"<<endl;
				exit(5);
			}
			ifs >> temp;
			if(temp==";"){
				cout<< "Erreur dans la grammaire: partie droite vide"<<endl;
				exit(6);
			}
			while(temp != ";" && !ifs.eof()){

				if((index=indexDuNonTerminal(temp))!=-1){

					prod->addSymboleADroite(snterminaux[index]);
				}
				else if((index=indexDuTerminal(temp))!=-1){
					prod->addSymboleADroite(sterminaux[index]);
				}									
				else{
					cout<< "Erreur dans la grammaire: symbole  '" << temp << "' non declar"<<endl;
					exit(4);
				}

				ifs >> temp;
			}
			if(temp!=";"){
				cout << "Erreur dans la grammaire, il manque un ';' "<< endl;
				exit(7);
			}
			grammaire.push_back(prod);




			//travaille pour grammaire




			//travaille pour grammaire
		}


	}



}

void ASantaxique::afficherGrammaire()
{		cout<<"La grammaire:"<<endl;
	for(unsigned int i=0;i<grammaire.size();i++){
		
		cout << "\t"<< nterminaux[grammaire[i]->getGauche()->getId()] << " := " ;
		for (unsigned int j = 0;j<grammaire[i]->getDroite().size();j++){
			if(	grammaire[i]->getDroite()[j]->isTerminal())
				cout <<	  terminaux[grammaire[i]->getDroite()[j]->getId()] << "";
			else
				cout <<	  nterminaux[grammaire[i]->getDroite()[j]->getId()] << "";

		}
		cout << endl;
	}
}
ASantaxique::~ASantaxique(void)
{
}

int ASantaxique::indexDuTerminal(std::string terminal)
{
	int f=terminaux.size();
	for(int i=0;i<f;i++)
		if(terminaux[i]==terminal)return i;
	return -1;
}
int ASantaxique::indexDuNonTerminal(std::string nterminal)
{
	int f=nterminaux.size();
	for(int i=0;i<f;i++)
		if(nterminaux[i]==nterminal)return i;
	return -1;
}

void ASantaxique::calculerPremier(){

	for(unsigned int i=0;i<grammaire.size();i++){
		if(grammaire[i]->getDroite().size()==1 && grammaire[i]->getDroite()[0]->isTerminal() && grammaire[i]->getDroite()[0]->getId()==0){
			grammaire[i]->getGauche()->ajouterPremier(0);
			//cout<< snterminaux[0]->getPremier().size();

		}

	}

	bool continuer  = true;
	while(continuer){
		continuer=false;
		for(unsigned int i=0;i<grammaire.size();i++){
			unsigned int j;
			continuer = continuer || grammaire[i]->getGauche()->ajouterPremier(grammaire[i]->getDroite()[0],true);
			if(grammaire[i]->getDroite()[0]->isContientEpsilon()){
				for(j=1;j<grammaire[i]->getDroite().size();j++){
					continuer = continuer || grammaire[i]->getGauche()->ajouterPremier(grammaire[i]->getDroite()[j],true);
					if(!grammaire[i]->getDroite()[j]->isContientEpsilon())break;
				}
				if(j==grammaire[i]->getDroite().size())continuer  = continuer || grammaire[i]->getGauche()->ajouterPremier(0);
			}

		}


	}


}

void ASantaxique::afficherPremier(){
	/*cout << "Terminaux" <<endl  ;
	for(unsigned int i=0;i<terminaux.size();i++){
	cout << "Premier( " <<terminaux[i] << " ) = " ;
	for(unsigned int j=0;j<sterminaux[i]->getPremier().size();j++){
	cout << terminaux[sterminaux[i]->getPremier()[j]] << " ";
	}
	cout <<endl;
	}	  */

	cout <<endl<< "Premier des Non Terminaux" <<endl;
	for(unsigned int i=0;i<nterminaux.size();i++){
		cout << "Premier( " <<nterminaux[i] << " ) = " ;
		for(unsigned int j=0;j<snterminaux[i]->getPremier().size();j++){
			cout << terminaux[snterminaux[i]->getPremier()[j]] << " ";
		}
		cout <<endl;
	}

}

void ASantaxique::calculerSuivant()
{
	snterminaux[0]->ajouterSuivant(1);
	for(unsigned int i=0;i<grammaire.size();i++){
		for(unsigned int j=0;j<grammaire[i]->getDroite().size()-1;j++){
			if(!grammaire[i]->getDroite()[j]->isTerminal()){
				(grammaire[i]->getDroite()[j])->ajouterPremierASuivant(grammaire[i]->getDroite()[j+1],true);
			}
		}

	}

	bool continuer = true;
	while(continuer){
		continuer=false;
		for(unsigned int i=0;i<grammaire.size();i++){
			unsigned int j;
			for(j=0;j<grammaire[i]->getDroite().size();j++){
				unsigned int k;
				if(!grammaire[i]->getDroite()[j]->isTerminal()){
					for(k=j+1;k<grammaire[i]->getDroite().size();k++){
						if(!grammaire[i]->getDroite()[k]->isContientEpsilon())break;
					}
					if(k==grammaire[i]->getDroite().size())
						continuer=continuer||grammaire[i]->getDroite()[j]->ajouterSuivant(grammaire[i]->getGauche());

				}

			}	  
		}		  

	}			  

}



void ASantaxique::afficherSuivant(){


	cout <<endl<< "Suivants des Non Terminaux" <<endl;
	for(unsigned int i=0;i<nterminaux.size();i++){
		cout << "Suivant( " <<nterminaux[i] << " ) = " ;
		for(unsigned int j=0;j<snterminaux[i]->getSuivant().size();j++){
			cout << terminaux[snterminaux[i]->getSuivant()[j]] << " ";
		}
		cout <<endl;
	}

}

int ASantaxique::fermetureItem(EnsembleItem& item)
{
	EnsembleItem* items= new EnsembleItem();
	int index,ancien;
	for(unsigned int i=0;i<item.size();i++){
		items->push_back(item[i]);
		ajouterItem(item[i]);
	}
	bool continuer= true;
	Symbole* sym;
	while(continuer){
		continuer = false;
		for(unsigned int i=0;i<items->size();i++){
			sym = (*items)[i]->getSymboleDevantPos();
			if(!sym)
				break;
			if(!sym->isTerminal()){
				for(unsigned int j=0;j<grammaire.size();j++){
					if(grammaire[j]->getGauche() == sym){
						//if(grammaire[j]->getDroite()[0]->getId()==0)continue;
						Item* it = new Item(grammaire[j],0);
						ancien = lstitem.size();
						index=ajouterItem(it);
						if(lstitem.size() == ancien){
							delete it;
							it=lstitem[index];
						}

						
						unsigned int k = 0;
						for(;k<items->size();k++)
							if((*items)[k]==it)break;
						if(k==items->size()){items->push_back(it);
						continuer= true;}

					}
				}
			}


		}

	}
	int ind;
	
	if((ind=indexDuEnsemble(*items))==-1){
		ensembles.push_back(items);
		return ensembles.size()-1;
	}
	else{
		return ind;
	}


}

int ASantaxique::ajouterItem(Item *item)
{
	for(unsigned int i=0; i<lstitem.size();i++){
		if(*item == *lstitem[i])return i;
	}
	lstitem.push_back(item);
	return lstitem.size()-1;
}

int ASantaxique::indexDuEnsemble(EnsembleItem &ens){
	for(unsigned int i=0;i<ensembles.size();i++){
		if( ensembleEgaux( *ensembles[i]	,ens))return i;
	}
	return -1;

}

bool ASantaxique::ensembleEgaux(EnsembleItem& ens1 , EnsembleItem& ens2){
	unsigned int i;
	unsigned int j;
	for(i=0;i<ens1.size();i++){
		for(j=0;j<ens2.size();j++){
			if(*ens2[j]==*ens1[i])break;
		}
		if(j==ens2.size())return false;	
	}
	return true;
}

int ASantaxique::Transition(EnsembleItem* ens,Symbole* sym){
	EnsembleItem* enstemp= new EnsembleItem();
	Symbole* it;
	int index,ancien;
	for(unsigned int i=0; i< ens->size();i++){
		it = (*ens)[i]->getSymboleDevantPos();
		if(it == sym){
			Item* item = new Item((*ens)[i]->getProd(),(*ens)[i]->getPosition() +1);
			ancien = lstitem.size();
			index=ajouterItem(item);
			if(lstitem.size() == ancien){
				delete item;
				item=lstitem[index];
			}
			enstemp->push_back(item);

		}
	}
	
	ancien = ensembles.size();
	if(enstemp->size()==0){delete enstemp;return -1;}
	index = fermetureItem(*enstemp);
	if(index == ancien){  lstetats.push_back(new TTransition())  ;return index;}
	delete enstemp;
	return index;

}


void ASantaxique::afficherEnsemble(EnsembleItem& ens)
{
	cout << endl;
	for(unsigned int i=0;i<ens.size();i++){
		cout << "\t"<< nterminaux[ens[i]->getProd()->getGauche()->getId()] << " := " ;
		unsigned int j ;
		for (j= 0;j<ens[i]->getProd()->getDroite().size();j++){
			if(j== ens[i]->getPosition())cout << ".";
			if(	ens[i]->getProd()->getDroite()[j]->isTerminal())
				cout <<	  terminaux[ens[i]->getProd()->getDroite()[j]->getId()] << "";
			else
				cout <<	  nterminaux[ens[i]->getProd()->getDroite()[j]->getId()] << "";

		}
		if(j== ens[i]->getPosition())cout << ".";
		cout << endl;
	}
	cout << endl;
}
void ASantaxique::creerCollectionItem(){
	NonTerminal* axiome=new NonTerminal(snterminaux.size());
	snterminaux.push_back(axiome);
	nterminaux.push_back("Axiome");
	Production* prod= new Production(axiome);
	prod->addSymboleADroite(snterminaux[0]);
	grammaire.push_back(prod);
	EnsembleItem ens;
	ens.push_back(new Item(prod,0));
	//ens.push_back(new Item(grammaire[3],2));
	//ens.push_back(new Item(grammaire[0],1));

	int ind= fermetureItem(ens);
	lstetats.push_back(new TTransition())  ;

	unsigned int i=0;
	while(i<ensembles.size()){
		for(unsigned int j=0;j<snterminaux.size();j++){
			ind= Transition(ensembles[i],snterminaux[j]);		
			/*if(ind!=-1)*/(*lstetats[i])[snterminaux[j]]=ind;
		}
		for(unsigned int j=0;j<sterminaux.size();j++){
			ind= Transition(ensembles[i],sterminaux[j]);	
			/*if(ind!=-1)*/(*lstetats[i])[sterminaux[j]]=ind;
		}
		i++;



	}




}
void ASantaxique::afficherCollectionItem(){
	unsigned int i;
 for(i=0;i<ensembles.size();i++){
		cout <<endl;
		cout << "I" << i << "={";  
		for(unsigned int k=0;k<lstetats.size();k++){
	for(unsigned int j=0;j<snterminaux.size();j++){
		if(((*lstetats[k])[snterminaux[j]])==i)
			cout <<"Transition(I"<< k<<","<< nterminaux[j]<<") ";
			//cout <<  (*lstetats[k])[snterminaux[j]] << endl << i << endl;
		}
	for(unsigned int j=0;j<sterminaux.size();j++){
		if(((*lstetats[k])[sterminaux[j]])==i)			
			cout <<"Transition(I"<< k<<","<< terminaux[j]<<") ";
		}
		}
		cout<<"}:     " << endl ;
		afficherEnsemble(*(ensembles[i]));
		}	 
	

}

void ASantaxique::afficherTransitions()
{
		for(unsigned int z=0;z<lstetats.size();z++){
		TTransition::const_iterator it1=lstetats[z]->begin();
		cout << "I"<<z<<endl;
		while(it1 != lstetats[z]->end()){
			if((*it1).second != -1 ){
			if((*it1).first->isTerminal()){
				cout <<"\t"<<  terminaux[(*it1).first->getId()] << " -> "<< (*it1).second <<endl;
			}else{
			    cout <<"\t"<<  nterminaux[(*it1).first->getId()] << " -> "<< (*it1).second <<endl;
			}
			}
			++it1;
		}
		}
}
   
void ASantaxique::construireTableAnalyse(){
	unsigned int i,j;
	Symbole* sym;
	for(i=0;i<lstetats.size();i++){
		successeur.push_back(new EntreeSucc);
		action.push_back(new EntreeAction);
	}
	
	for(i=0;i<   lstetats.size();i++){
		 for(j=0;j<   snterminaux.size();j++){
		(*successeur[i])[snterminaux[j]] = (*lstetats[i])[snterminaux[j]];


		 }
	}

	for(i=0;i<ensembles.size();i++){
		for(j=0;j<ensembles[i]->size();j++){
			if((*ensembles[i])[j]->getProd()->getGauche() == snterminaux[snterminaux.size()-1]){
				if((*ensembles[i])[j]->getSymboleDevantPos()==NULL){
					Action act ;
					act.act = ACCEPTER;
					
					(*action[i])[sterminaux[1]] = act;
					continue;

				}									   
			}
			sym = (*ensembles[i])[j]->getSymboleDevantPos();
			if(!sym){
				Action act ;
				act.act = REDUIRE;
				act.num = indexDuProduction((*ensembles[i])[j]->getProd()) ;
				//if (act.num == -1)perror("erreur");
				for(unsigned z=0;z<	(*ensembles[i])[j]->getProd()->getGauche()->getSuivant().size();z++){
					int e=(*action[i])[sterminaux[(*ensembles[i])[j]->getProd()->getGauche()->getSuivant()[z]]].act;
					if(e== REDUIRE ){
						cout<< "Conflit Reduction Reduction avec  le terminal "<<terminaux[(*ensembles[i])[j]->getProd()->getGauche()->getSuivant()[z]]<<endl;
					cout << "I" << i;
					afficherEnsemble(*ensembles[i]);
					}
					else if(e == DECALER){
					 cout<< "Conflit Reduction Decalage avec  le terminal "<<terminaux[(*ensembles[i])[j]->getProd()->getGauche()->getSuivant()[z]]<<endl;
					cout << "I" << i;
					afficherEnsemble(*ensembles[i]);
					}
					
					(*action[i])[sterminaux[(*ensembles[i])[j]->getProd()->getGauche()->getSuivant()[z]]] = act;
					
				}

			}
			else if (sym->isTerminal()){
				Action act ;
				act.act = DECALER;
				act.num = (*lstetats[i])[sym];
				int e= (*action[i])[(Terminal*)sym].act;
								if(e== REDUIRE ){
									cout<< "Conflit Reduction Decalage avec le terminal "<<terminaux[sym->getId()]<<endl;
						cout << "I" << i;
						afficherEnsemble(*ensembles[i]);
					}
				
				 (*action[i])[(Terminal*)sym] = act;
				
			}

		}




	}


}

int ASantaxique::indexDuProduction(Production *prod){
  	int f=grammaire.size();
	for(int i=0;i<f;i++)
		if(grammaire[i]==prod)return i;
	return -1;
}

void ASantaxique::afficherespace(int e){
for(int i=0;i<e;i++)cout<<" ";
}
void ASantaxique::afficherTableAnalyse(){
	unsigned int i,j,k;
	Action act;
   cout  << "Etat        Action                  Successeur " <<endl;
   cout << "    ";
   for(i=2;i<terminaux.size();i++){cout << terminaux[i];afficherespace(7-terminaux[i].length());}
   cout <<" "<< terminaux[1]<<"     ";
   for(i=0;i<nterminaux.size()-1;i++){cout <<" "<< nterminaux[i];afficherespace(7-nterminaux[i].length());}
   cout<<endl;
   for(i=0;i<lstetats.size();i++){
	   cout << "I" << i;if(i>9)cout<<" ";else cout<<"  ";
	   for(j=2;j<terminaux.size();j++){
		   act= (*action[i])[sterminaux[j]];
		   if(act.act==DECALER){
			   cout  << " D" <<  act.num;
			   if(act.num <10)
				   afficherespace(4);
			   else
				   afficherespace(3);
		   }
		   else if(act.act == REDUIRE){
			   cout  << " R" <<  act.num+1;
			   if(act.num < 10)afficherespace(4);
			   else
				   afficherespace(3);
		   }else if(act.act == ACCEPTER)
		   {
			   cout << " ACC   ";
		   }
		   else cout<<"       ";
	   }
	   act= (*action[i])[sterminaux[1]];
		   if(act.act==DECALER){
			   cout  << " D" <<  act.num;
		if(act.num < 10)afficherespace(4);
			   else
				   afficherespace(3);

		   }
		   else if(act.act == REDUIRE){
			   cout  << " R" <<  act.num+1;
			   if(act.num-1 < 10)afficherespace(4);
			   else
				   afficherespace(3);
		   }else if(act.act == ACCEPTER)
		   {
			   cout << " ACC   ";
		   }
		   else cout<<"       ";

	   for(j=0;j<nterminaux.size()-1;j++){
		k=   (*successeur[i])[snterminaux[j]];
		if(k!=-1){cout<<" "<<k<<" ";if(k< 10)afficherespace(4);
			   else
				   afficherespace(3);}
		else cout <<"       ";
	   }
	   
	   cout << endl;
		


   }

}

bool ASantaxique::analyser(bool afficher){
	
	vector<Information> apop ;
	ASemantique semant(this);
	if(affichage)cout << endl<<"Trace d'analyse santaxique ascendant" <<endl;
	stack<Information> pile;
	Information info,lus ;
	info.type = ALexical::LEXICAL_SANTAXIQUE_ETAT; 
	info.etat= 0;
	pile.push(info);
	while(true){
		lus = analyseurlexical.voirSuivant();
		//if(lus.type == ALexical::LEXICAL_NOMBRE)
		//cout << lus.valeur.Entier << endl;
		//else{
//		if(lus.type == ALexical::LEXICAL_PLUS)cout <<"+";
			//if(lus.type == ALexical::LEXICAL_FOIS) cout << "*";

		//}

		if((*action[pile.top().etat])[sterminaux[lus.type]].act == DECALER  ){
			info.etat=(*action[pile.top().etat])[sterminaux[lus.type]].num; 
			info.type = ALexical::LEXICAL_SANTAXIQUE_ETAT;
			if(affichage){
			cout << "decalage      :  " ;
			if(lus.type==analyseurlexical.LEXICAL_INT)
				cout<<lus.valeur.Entier << endl;
			else
					//case ALexical::LEXICAL_TYPE_CHAR:
					//cout<<lus.valeur. << endl;break;
					if(lus.type== analyseurlexical.LEXICAL_TYPE_CHAINE)
						cout<<lus.valeur.Chaine << endl;
					else
					if(lus.type== analyseurlexical.LEXICAL_DOUBLE)
					cout<<lus.valeur.Double << endl;
					else
					if(lus.type== analyseurlexical.LEXICAL_FLOAT)
						cout<<lus.valeur.Double << endl;
					else

						if(lus.type == analyseurlexical.LEXICAL_POINT_VERGULE)cout<<";"<<endl;
						else
						cout<<analyseurlexical.terminale[lus.type-2]<<endl;
			}

		 pile.push(analyseurlexical.getSuivant());
		 pile.push(info);
		}
		else if((*action[pile.top().etat])[sterminaux[lus.type]].act == REDUIRE ){
			if(affichage){cout << "Reduction par :  ";}
			Production* p = grammaire[(*action[pile.top().etat])[sterminaux[lus.type]].num];
			int u =  (*action[pile.top().etat])[sterminaux[lus.type]].num;

			
if(affichage)cout << nterminaux[grammaire[u]->getGauche()->getId()] << " := " ;
		for (unsigned int y = 0;y<grammaire[u]->getDroite().size();y++){
			if(	grammaire[u]->getDroite()[y]->isTerminal())
				if(terminaux[grammaire[u]->getDroite()[y]->getId()] == ";;")
					if(affichage)cout<<";";
				else
				if(affichage)cout <<	  terminaux[grammaire[u]->getDroite()[y]->getId()] << " ";
			else
				if(affichage)cout <<	  nterminaux[grammaire[u]->getDroite()[y]->getId()] << " ";
		}if(affichage)cout<<endl;

			for(unsigned int i=0;i<p->getDroite().size();i++){
				apop.push_back(pile.top());
				pile.pop();
				pile.pop();
			}
			//
			info = semant.action(p,apop);
			apop.clear();

			//
			//info.type = ALexical::LEXICAL_SANTAXIQUE_NTERMINAL;
			//info.valeur.Entier = p->getGauche()->getId();	
				int nouveauetat = pile.top().etat;
				pile.push(info);
				//
				
				//
				info.type= ALexical::LEXICAL_SANTAXIQUE_ETAT;
				info.etat = (*successeur[nouveauetat])[p->getGauche()]  ;
				pile.push(info);
				
		}
		else if((*action[pile.top().etat])[sterminaux[lus.type]].act == ACCEPTER){
			if(affichage)cout << "ACCEPT"<< endl;
			if(generation)semant.afficher();
			return true;
		}
		else{
		//	if(affichage)cout << analyseurlexical.voirSuivant().type;
			return false;
			
		}

	}
	 

	


}