#pragma once
#define	 MARQUEUR_FIN "$"
#include<vector>
#include<string>
#include<map>
#include"ALexical.h"
#include<stack>
#include"Item.h"
#include "Terminal.h"
#include "Production.h"
using namespace std;
	struct Action{
	  char act;
	  int num;
	};
typedef vector<Item*> EnsembleItem;	
typedef map<Symbole*,int> TTransition;
typedef map<Terminal*,Action> EntreeAction;
typedef map<NonTerminal*,int> EntreeSucc;

class ASantaxique
{
	static const char REDUIRE = 3;
	static const char DECALER = 4;
	static const char ACCEPTER = 5;
	
public:ALexical analyseurlexical;
private:
	   vector<EntreeSucc*> successeur;
	   bool generation ;
	vector<EntreeAction*> action;
	EnsembleItem lstitem;
	bool affichage;

	vector<TTransition*> lstetats;
	vector<EnsembleItem*> ensembles;
public:vector<string> terminaux,nterminaux;
private:vector<Terminal*> sterminaux;
	vector<NonTerminal* > snterminaux;

	vector<Production*> grammaire;
	int indexDuTerminal(string terminal);
	void chargerGrammaire(char*);
	
	int indexDuEnsemble(EnsembleItem& ens);
	void calculerPremier();
	void calculerSuivant();
	int ajouterItem(Item* item);
	int fermetureItem(EnsembleItem& item);
	
	void creerCollectionItem();
	void afficherespace(int e);
	
	void construireTableAnalyse();
	int Transition(EnsembleItem* ens,Symbole* sym);
	bool ensembleEgaux(EnsembleItem& ens1 , EnsembleItem& ens2);
	int indexDuNonTerminal(string nonterminal);
	

public:
	int indexDuProduction(Production* prod);
void activerGenerationCode(bool);
		void activerAffichageAnalyse(bool);
	bool analyser(bool afficher=false);
	void afficherEnsemble(EnsembleItem& ens);
	void afficherSuivant();
	void afficherPremier();
	void afficherTableAnalyse();
	void afficherTransitions();
	void afficherCollectionItem();
	ASantaxique(char* fichier_grammaire,char* lexical,int nb_terminal = 200,int nb_nterminal=200,int nb_prod=200);
	void afficherGrammaire();
	~ASantaxique(void);
};
